#include <zombie_escape>

new cvar_allow_donation

public plugin_init()
{
	register_plugin("[ZE] EC Donation", "1.0", "Raheem")
	
	// Cvars
	cvar_allow_donation = register_cvar("ze_allow_donation", "1")
	
	// Commands
	register_clcmd("say", "Cmd_Say")
	register_clcmd("say_team", "Cmd_Say")
	
	// Tasks
	set_task(120.0, "Donate_Notice", _, _, _, "b")
}

public Donate_Notice()
{
	if(get_pcvar_num(cvar_allow_donation))
	{
		ze_colored_print(0, "!tTo donate others Escape Coins!y, !tsay !g/donate")
	}
}

public Cmd_Say(id)
{
	new szSaid[64]
	
	read_args(szSaid, charsmax(szSaid))
	remove_quotes(szSaid)
	
	new szTemp1[16]
	new szTemp2[32]
	
	strbreak(szSaid, szTemp1, charsmax(szTemp1), szTemp2, charsmax(szTemp2))
	
	if (get_pcvar_num(cvar_allow_donation) && equal(szTemp1,"/donate", 7))
	{
		Donate(id, szTemp2)
	}
}

public Donate(id, arg[])
{
	new szReciverName[32], szAmount[10]
	strbreak(arg, szReciverName, charsmax(szReciverName), szAmount, charsmax(szAmount))
	
	if (!szReciverName[0] || !szAmount[0])
	{
		ze_colored_print(id, "!tUsage!y: !gsay /donate <name> <amount>")
		return
	}
	
	new iCurrentEC = ze_get_escape_coins(id)
	new iECDonation
	
	if (equal(szAmount, "all"))
	{
		iECDonation = iCurrentEC
	}
	else
	{
		iECDonation = str_to_num(szAmount)
	}

	if (iECDonation <= 0)
	{
		ze_colored_print(id, "!tWrong Escape Coins quantity!y!")
		return
	}
	
	iCurrentEC -= iECDonation
	
	if (iCurrentEC < 0)
	{
		iECDonation += iCurrentEC
		iCurrentEC = 0
		
	}
	
	new iReciver = get_user_index(szReciverName)
	
	if (!iReciver || iReciver == id)
	{
		ze_colored_print(id, "!tPlayer !g%s !thas not been found on the server!y!", szReciverName)
		return
	}
	
	ze_set_escape_coins(iReciver, ze_get_escape_coins(iReciver) + iECDonation)
	ze_set_escape_coins(id, iCurrentEC)
	
	new szDonatorName[32]
	get_user_name(id, szDonatorName, 31)
	
	set_hudmessage(255, 0, 0, -1.0, 0.3, 0, 6.0, 6.0)
	show_hudmessage(0, "%s donated %d Escape Coins to %s!", szDonatorName, iECDonation, szReciverName)
}